﻿#include "smartCar.h"


SmartClass::SmartClass(){
	pinMode(2, OUTPUT);
	pinMode(3, OUTPUT);
	pinMode(4, OUTPUT);
	pinMode(5, OUTPUT);
	pinMode(6, OUTPUT);
  	pinMode(7, OUTPUT);
 	pinMode(8, OUTPUT);
  	pinMode(9, OUTPUT);
	pinMode(10, OUTPUT);
	pinMode(11, OUTPUT);
	pinMode (A2, INPUT);
	pinMode (A3, INPUT);
	pinMode (A4, INPUT);
	pinMode (A5, INPUT);
  level = 0;
	distance = 0;
	duration = 0;
	line_left = 0;
	line_right = 0;

}

double SmartClass::distancesensor(){
	digitalWrite(13, LOW);
	delayMicroseconds(2);
	digitalWrite(13, HIGH);
	delayMicroseconds(10);
	digitalWrite(13, LOW);
	duration = pulseIn(12, HIGH);
	distance = duration / 58.2;
	delay(50);
	return distance;
}
int SmartClass::linesensor(){
	line_left = analogRead(A2);
	line_right = analogRead(A3);
	if (line_left < 800 && line_right < 800){
		return 3;
	}
	else if (line_left < 800 && line_right > 800){
		return 2;
	}
	else if (line_left > 800 && line_right < 800){
		return 1;
	}
	else {
		return 0;
	}
}
void SmartClass::ledcolor(int red, int green, int blue){
	analogWrite(3, blue);
	analogWrite(5, green);
	analogWrite(6, red);

}
void SmartClass::motor(int motor_id, int speed){
	if (motor_id == 1) {
		if (speed < 0) {
			digitalWrite(9, LOW);
			speed = -speed;
		}
		else if (speed > 0){
			digitalWrite(9, HIGH);
		}
		else {
			digitalWrite(9, LOW);
		}
		analogWrite(5, speed);
	}
	if (motor_id == 2) {
		if (speed < 0) {
			digitalWrite(10, LOW);
			speed = -speed;
		}
		else if (speed > 0){
			digitalWrite(10, HIGH);
		}
		else {
			digitalWrite(10, LOW);
		}
		analogWrite(3, speed);
	}
}
void SmartClass::move(int direction, int speed){
	if (direction == 1){
		digitalWrite(9, HIGH);
		digitalWrite(10, HIGH);
		digitalWrite(6,LOW);
    		digitalWrite(11,LOW);
	}else if(direction == 2){
		digitalWrite(6, HIGH);
		digitalWrite(11, HIGH);
    		digitalWrite(9, LOW);
    		digitalWrite(10, LOW);
	}else if(direction == 3){
		digitalWrite(9, HIGH);
		digitalWrite(10, LOW);
    		digitalWrite(6,LOW);
    		digitalWrite(11,LOW);
	}else if(direction == 4){
		digitalWrite(9, LOW);
		digitalWrite(10, HIGH);
    		digitalWrite(6,LOW);
    		digitalWrite(11,LOW);
	}
	analogWrite(3, speed);
  	analogWrite(5, speed);
}
